# -*- coding: utf-8 -*-
"""
Created on Mon Jun 15 14:44:54 2015

@author: Zhou
"""
import PSR
import csv
import numpy as np
import math

#given the parameters write each sequence as a row in the csv file
def writeCsv(mu, Sigma, G, sigma, C, m, length, number, filename):
    sequences = []
    for i in range(number):
        sequences.append(PSR.generate(mu, Sigma, G, sigma, C, m, length)[0])
    with open(filename, 'wb') as csvfile:
        obswriter = csv.writer(csvfile, delimiter=',')
        for num in range(len(sequences)):
            row = []
            for obs in range(len(sequences[num])):
                #print sequences[num][obs]
                row.append(np.array(sequences[num][obs]).flatten())
            obswriter.writerow(row)
            
"""def writeCsv(x1, Atrue, Ctrue, Qtrue, Rtrue, P, m, length, number, filename):
    sequences = []
    for i in range(number):
        sequences.append(PSR.YGenerator(x1, Atrue, Ctrue, Qtrue, Rtrue, P, length))
    with open(filename, 'wb') as csvfile:
        obswriter = csv.writer(csvfile, delimiter=',')
        for num in range(len(sequences)):
            row = []
            for obs in range(len(sequences[num])):
                #print sequences[num][obs]
                row.append(np.array(sequences[num][obs]).flatten())
            obswriter.writerow(row)"""

#write the pre-generated sequences to the csv file
def writeCSV(obsSeq, filename):
    with open(filename, 'wb') as csvfile:
        obswriter=csv.writer(csvfile, delimiter = ',')
        for num in range(len(obsSeq)):
            row = []
            for obs in range(len(obsSeq[num])):
                row.append(np.array(obsSeq[num][obs]).flatten())
            obswriter.writerow(row)

#this reads a csv file with sequences on it, however it is hardcoded so check the dimension of the observation before using this
def readCsv(filename):
    sequences = []
    with open(filename, 'rb') as csvfile:
        #print "start reading"
        filereader = csv.reader(csvfile, delimiter=',')
        #print "done reading ", filename 
        for row in filereader:
            if len(row) > 0:
                sequence = []
                for item in row:
                    pos = item.split(' ')
                    k = len(pos)
                    for i in range(k-1, -1, -1):
                        if pos[i] == '' or pos[i] == '[' or pos[i] ==']':
                            pos.remove(pos[i])
                    k = len(pos)
                    """x = pos[0].split('[')
                    y = pos[1].split(']')
                    if len(x) > 1:
                        x = x[1]
                    else:
                        x = x[0]
                    y = y[0]
                    #sequence.append(np.matrix([[(float(x)-1964)/(2659 - 1964)],[(float(y)-0.25)/(1.6-0.25)]]))
                                        
                    sequence.append(np.matrix([[float(x)],[float(y)]]))"""
                    """x = pos[0].split('[')
                    y = pos[1]
                    z = pos[2].split(']')
                    if len(x) > 1:
                        x = x[1]
                    else:
                        x = x[0]
                    z = z[0]
                    print x
                    print y
                    print z
                    sequence.append(np.matrix([[float(x)], [float(y)], [float(z)]]))"""
                    state = []  
                    if len(pos) > 1:
                        for i in range(len(pos)):
                            if i == 0:
                                x = pos[0].split('[')
                                if len(x) >1:
                                    x= x[1]
                                else:
                                    x = x[0]
                                state.append([float(x)])
                            elif i == len(pos)-1:
                                z = pos[i].split(']')
                                z = z[0]
                                state.append([float(z)])
                            else:
                                state.append([float(pos[i])])  
                    if len(pos) == 1:
                        x = pos[0].split('[')
                        if len(x) >1:
                            x= x[1]
                        else:
                            x = x[0]
                        x = x.split(']')
                        x = x[0]
                        state.append([float(x)])
                    sequence.append(np.matrix(state))
                #print sequence    
                sequences.append(sequence)                
    return sequences

# read the parameters on the files written by the matlab code
def readEM(filename, n, m):
    with open(filename, 'rb') as csvfile:
        filereader = csv.reader(csvfile, delimiter=',')
        A = []
        C = []
        Q = []
        R = []
        x0 = []
        P0 = []
        counter = 0
        for row in filereader:
            if counter >= 0 and counter < n:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                A.append(MatRow)
            if counter >= n and counter < n+m:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                C.append(MatRow)
            if counter >= n+m and counter < n*2+m:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                Q.append(MatRow)
            if counter >= n*2+m and counter < n*2+m*2:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                R.append(MatRow)
            if counter >= n*2+m*2 and counter < n*3+m*2:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                x0.append(MatRow)
            if counter >= n*3+m*2 and counter < n*4+m*2:
                MatRow = []
                for num in row:
                    MatRow.append(float(num))
                P0.append(MatRow)
            counter = counter + 1
        A = np.matrix(A)
        C = np.matrix(C)
        Q = np.matrix(Q)
        R = np.matrix(R)
        x0 = np.matrix(x0)
        P0 = np.matrix(P0)
    return (A, C, Q, R, x0, P0)

# generate the prediction of a particular sequence
def Sequencing(mu, Sigma, Gprime, C, SigmaDelta, test, m, n, num):
    sequence = test[num]
    J = np.matrix(np.concatenate((np.identity(m), np.zeros((m, (n-1)*m))), axis=1))
    length = len(sequence)
    muP = mu
    SigmaP = Sigma
    predSequence = []
    for i in range(length):
        pred = J * muP
        muP, SigmaP = PSR.prediction(muP, Gprime, C, SigmaDelta, SigmaP, m, n, sequence[i], Sigma)
        predSequence.append(pred)
    return predSequence

#this uses the prediction function to calculate the difference between real observation and the predicted observation in order to calculate the average difference
def update(mu,Sigma, Gprime, C, SigmaDelta, test, m, n, step):
    J = np.matrix(np.concatenate((np.identity(m), np.zeros((m, (n-1)*m))), axis=1))
    diffT = 0
    llh = 0
    differences = []
    likelihoodcount = len(test)
    num = 0
    for sequence in test:
        num = num + 1
        printT = False
        if num == 1:
            printT = True
        difference = 0
        muP = mu
        SigmaP = Sigma
        Sigmas = []
        Mus = []
        Ys = []
        #print "new term"
        #print len(sequence)
        length = len(sequence)
        for i in range(length - step + 1):
            if step == 1:
                pred = J * muP
            if step == 2:
                pred = J * Gprime * muP
            if step == 3:
                pred = J * Gprime * Gprime * muP
            if step == 4:
                pred = J * Gprime * Gprime * Gprime * muP
            if step == 5:
                pred = J * Gprime * Gprime * Gprime * Gprime *muP
            #if i < length-n:
            Sigmas.append(SigmaP[0:m, 0:m])
            Mus.append(pred)
            #ObsMu = []
            """for j in range(n):
            for k in range(m):
            ObsMu.append(sequence[i+j][k, 0]) """  
            Ys.append(sequence[i])
            """if math.isnan(pred[0, 0]) or math.isnan(pred[1, 0]):
                distance = np.inf
                
            else:
                
                 MADE CHANGES HERE
                
                if step == 1:               
                    #distance = np.sqrt((pred[0, 0] - sequence[i][0, 0])**2 + (pred[1, 0]-sequence[i][1, 0])**2)
                    #distance = np.sqrt(((pred[0, 0] - sequence[i][0, 0])/sequence[i][0, 0])**2 + ((pred[1, 0]-sequence[i][1, 0])/sequence[i][1, 0])**2)                
                    distance = np.linalg.norm(pred - sequence[i])
                if step == 2:
                    distance = np.sqrt((pred[0, 0] - sequence[i+1][0, 0])**2 + (pred[1, 0]-sequence[i][1, 0])**2)
                if step == 3:
                    distance = np.sqrt((pred[0, 0] - sequence[i+2][0, 0])**2 + (pred[1, 0]-sequence[i][1, 0])**2)
                if step == 4:
                    distance = np.sqrt((pred[0, 0] - sequence[i+3][0, 0])**2 + (pred[1, 0]-sequence[i][1, 0])**2)            
                if step == 5:
                    distance = np.sqrt((pred[0, 0] - sequence[i+4][0, 0])**2 + (pred[1, 0]-sequence[i][1, 0])**2)"""
            if math.isnan(pred[0, 0]):
                distance = np.inf
                
            else:
                if step == 1:               
                    distance = abs(pred[0, 0] - sequence[i][0, 0])
                if step == 2:
                    distance = abs(pred[0, 0] - sequence[i+1][0, 0])
                if step == 3:
                    distance = abs(pred[0, 0] - sequence[i+2][0, 0])
                if step == 4:
                    distance = abs(pred[0, 0] - sequence[i+3][0, 0])   
                
                differences.append(distance)
            difference = difference + distance
            muP, SigmaP = PSR.prediction(muP, Gprime, C, SigmaDelta, SigmaP, m, n, sequence[i], Sigma)
        difference = difference/(len(sequence) - step + 1)
        diffT = diffT + difference
        addon = PSR.likelihood(Sigmas, Mus, Ys, m, printT)
        #print len(Ys)
        #print "note"
        #print addon
        llh = llh + addon
        if addon == 0:
            likelihoodcount = likelihoodcount - 1
        #else:
        #print addon
        #print llh
    diffT = diffT/len(test)
    variance = 0
    if diffT == np.inf or math.isnan(diffT):
        diffT = np.inf
        variance = np.inf
    else:
        for distance in differences:
            variance = variance + (distance - diffT)**2
        variance = variance/(len(test)*len(test[0]))
    #print llh
    if likelihoodcount == 0:
        likelie = 0
    else:
        likelie = llh/likelihoodcount
    #print likelihoodcount
    return (diffT, variance, likelie)
    
